package XWCH;

import java.io.IOException;
import java.util.Random;

/**
 *
 * @author kchantola
 */
public class LevelArray {
    NationRegion nr;
    Random rand = new Random();
    
    
    public String[][] getPartArray(int nsNumber, int id) throws IOException{
        ReadingTable rt = new ReadingTable();
        String[][] partArray = new String[nsNumber][4];//4: 4 levels: part/type3/type2/type1
                
        for(int i=0; i<partArray.length; i++){
            int pid = id;
            int plid = id;
            if(i>0){
                int r = -1;
                int partNumber = rt.countLinedNumber("data/part.tbl");
                while(r<0 || r> (partNumber - 1)){
                    r = rand.nextInt(id + nsNumber);
                }
                pid = r + 1;
                plid = rand.nextInt(pid) + 1;
            }
            
            partArray[i][0] = String.valueOf(pid);
            String line = rt.getLine("data/part.tbl", plid);
            
            String category = rt.getLinePart(line, "|", 5);
            for(int j=1; j<4; j++){
                partArray[i][j] = rt.getLinePart(category, " ", j);
            }
        }
        return partArray;
    }
    
    public String[][] getSupplierArray(int nsNumber, int id) throws IOException{
        String[][] supplierArray = new String[nsNumber][3];//3:3 levels: supplier/nation/region
        
        for(int i=0; i<supplierArray.length; i++){
            int sid = id;
            int snid = id;
            if(i>0){
                int r = -1;
                ReadingTable rt = new ReadingTable();
                int supplierNumber = rt.countLinedNumber("data/supplier.tbl");
                while(r<0 || r>(supplierNumber-1)){
                    r = rand.nextInt(id + nsNumber);
                }
                sid = r + 1;
                nr = new NationRegion("data/supplier.tbl", sid);
                snid = rand.nextInt(nr.getNationid()) + 1;
            }

            nr = new NationRegion("data/supplier.tbl", snid);
            supplierArray[i][0] = String.valueOf(sid);
            supplierArray[i][1] = nr.getNation();
            supplierArray[i][2] = nr.getRegion();
        }
        return supplierArray;
    }
    
    
    public String[][] getNationArray(int nsNumber, int id) throws IOException{
        String[][] nsArray = new String[nsNumber][2];//2: 2 levels: nation/region
        for(int i=0; i<nsArray.length; i++){
            int nid = id;
            if(i>0){
                ReadingTable rt = new ReadingTable();
                int nationNumber = rt.countLinedNumber("data/nation.tbl");
                nid = rand.nextInt(nationNumber) + 1;//random nation id
            }
                            
            nr = new NationRegion(nid);
            nsArray[i][0] = nr.getNation();
            nsArray[i][1] = nr.getRegion();
        }
        return nsArray;
    }
    
    
    public int[] geticLevels(int length){
        int[] icLevels = new int[length];
        //initializing
        for(int i=0; i<length; i++){
            icLevels[i] = -1;
        }
        //at least one level is incomplete, and at most all level are incomplete
        int s = 0;
        while (s == 0){
            for(int i=0; i< length; i++){
                icLevels[i] = rand.nextInt(length);
                if(icLevels[i] == i){
                    s++;
                }
            }
        }
        return icLevels;
    }
    
    public String[][] getComplexPartArray(String[][] nsArray){
        String[][] nsa = nsArray;
        int[] icPart = geticLevels(nsa.length);
        int levelLength = nsa[0].length - 1;//Exclude part level
        
        int[] level = new int[levelLength];
        for(int i=0; i<nsa.length; i++){
            if(icPart[i] == i){
                level = geticLevels(levelLength);
                for(int j=0; j<levelLength; j++){
                    if(level[j] == j){
                        nsa[i][j+1] = "null";
                    }
                }
            }
        }
        return nsa;
    }
    public String[][] getComplexNationArray(String[][] nsArray){
        String[][] nsa = nsArray;
        int[] icNation = geticLevels(nsa.length);
        int levelLength = nsa[0].length;
        int[] level = new int[levelLength];
        for(int i=0; i<nsa.length; i++){
            if(icNation[i] == i){
                level = geticLevels(levelLength);
                for(int j=0; j<levelLength; j++){
                    if(level[j] == j){
                        nsa[i][j] = "null";
                    }
                }
            }
        }
        return nsa;
    }
}
